package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	import net.flashpunk.tweens.misc.VarTween;
	import net.flashpunk.utils.Ease;
	
	/**
	 * ...
	 * @author Switchbreak
	 */
	public class Fader extends Entity 
	{
		
		private var curtain:Image;
		
		public function Fader( callback:Function = null, fDuration:Number = 0.5, bFadeIn:Boolean = false, color:uint = 0 ) 
		{
			curtain = Image.createRect( FP.width, FP.height, 0 );
			curtain.alpha = (bFadeIn ? 1 : 0);
			curtain.scrollX = curtain.scrollY = 0;
			
			super( 0, 0, curtain );
			
			var fadeTween:VarTween = new VarTween( callback, ONESHOT );
			fadeTween.tween( curtain, "alpha", (bFadeIn ? 0 : 1), fDuration, Ease.quadIn );
			addTween( fadeTween, true );
		}
		
	}

}