package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author Switchbreak
	 */
	public class PlatformWater extends Entity 
	{
		
		private static const PARTICLE_COUNT:int = 255;
		private static const WATER_SPEED:int = 50;
		private static const WATER_COLOR:uint = 0x288CFF;
		
		private var particles:Graphiclist;
		private var nStartY:int, nMinX:int, nWidth:int;
		
		public function PlatformWater( nSetStartY:int, nSetMinX:int, nSetWidth:int ) 
		{
			nStartY = nSetStartY;
			nMinX = nSetMinX;
			nWidth = nSetWidth;
			
			particles = new Graphiclist();
			particles.scrollX = particles.scrollY = 0;
			
			for ( var i:int = 0; i < PARTICLE_COUNT; i++ )
			{
				var nSize:int = 1;
				var nColorValue:int = FP.rand( 0x55 ) + 0xaa;
				var nParticleColor:uint = FP.getColorRGB( nColorValue, nColorValue, nColorValue );
				
				var particle:Image = Image.createRect( nSize, nSize, nParticleColor );
				particle.x = FP.rand( nWidth ) + nMinX;
				particle.y = nStartY;
				particle.alpha = 0.5;
				
				particles.add( particle );
			}
			
			super( 0, 0, particles );
			
			//active = false;
			layer = 20000;
		}
		
		override public function update():void 
		{
			var nMove:Number = WATER_SPEED * FP.elapsed;
			
			for ( var i:int = 0; i < PARTICLE_COUNT; i++ )
			{
				if ( particles.children[i].x < nMinX || particles.children[i].x > nMinX + nWidth )
				{
					particles.children[i].y += nMove;
					
					if ( particles.children[i].y > FP.height )
					{
						particles.children[i].x = FP.rand( nWidth ) + nMinX;
						particles.children[i].y = nStartY;
					}
				}
				else if ( particles.children[i].y < nStartY )
				{
					particles.children[i].y += nMove;
					
					if ( particles.children[i].y > nStartY )
					{
						particles.children[i].y = nStartY;
					}
				}
				else
				{
					particles.children[i].x += FP.random * 6 - 3;
					particles.children[i].y -= Math.round( FP.random );
				}
			}
			
			super.update();
		}
		
	}

}