package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author Switchbreak
	 */
	public class Waterfall extends Entity 
	{
		
		private static const PARTICLE_COUNT:int = 512;
		private static const WATER_SPEED:int = 50;
		private static const WATER_COLOR:uint = 0x288CFF;
		
		private var particles:Graphiclist;
		private var speeds:Vector.<int>;
		
		public function Waterfall() 
		{
			particles = new Graphiclist();
			particles.scrollX = particles.scrollY = 0;
			
			speeds = new Vector.<int>();
			
			for ( var i:int = 0; i < PARTICLE_COUNT; i++ )
			{
				var nSize:int = FP.rand( 15 ) + 5;
				var nColorValue:int = FP.rand( 0x55 ) + 0x22;
				var nParticleColor:uint = FP.getColorRGB( nColorValue, nColorValue, 0xff );
				
				var particle:Image = Image.createRect( nSize, nSize, nParticleColor );
				particle.x = FP.rand( FP.width );
				particle.y = FP.rand( FP.height );
				//particle.color = nParticleColor;
				particle.alpha = 0.5;
				
				particles.add( particle );
				speeds[i] = WATER_SPEED + FP.rand( 100 );
			}
			
			super( 0, 0, particles );
			
			//active = false;
			layer = 30000;
		}
		
		override public function update():void 
		{
			for ( var i:int = 0; i < PARTICLE_COUNT; i++ )
			{
				var nMove:Number = speeds[i] * FP.elapsed;
				
				particles.children[i].y += nMove;
				if ( particles.children[i].y > FP.height )
				{
					particles.children[i].x = FP.rand( FP.width );
					particles.children[i].y = -20;
				}
			}
			
			super.update();
		}
		
	}

}